import java.applet.Applet;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.net.URL;

import javax.imageio.ImageIO;

/**
 * 
 */

/**
 * @title Snowfox
 * @version 1.0
 * @author fukuda
 */
public class Snowfox extends Applet {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	int width;								//   Applet ̕
	int height;								//   Applet ̍

	BufferedImage offscreen_img;			//  ItXN[  Image
	Graphics2D offscreen_g;					//  ItXN[  Graphics

	GameKeyAdapter gk;						//  L[Cxgp
	GameMouseAdapter gm;					//  }EXCxgp
	ChipImage[] oci;						//  IWi`bv摜


	//  Applet ̃\bh  
	public void init(){


		//  N̏
		initOnload();
	}
	

	//  Applet ̃\bh   ʍXV
	public void paint(Graphics g){


		//  ItXN[̉摜  Applet ɕ`
		g.drawImage(offscreen_img, 0, 0, this);
	}


	//  Applet ̃\bh
	public void update(Graphics g) {
		paint(g);
	}


	//  N̏
	private void initOnload() {


		//  ̃Avbg̃TCY擾
		width = this.getWidth();
		height = this.getHeight();
		
		//  ItXN[쐬
		offscreen_img = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
		offscreen_g = offscreen_img.createGraphics();

		//  ItXN[𔒂œhԂ
		offscreen_g.setColor(Color.white);
		offscreen_g.fillRect(0, 0, width, height);
		offscreen_g.setColor(Color.black);

		//  IWi`bv摜
		oci = new ChipImage[256];
		for(int i = 0;i <= 255;i++){
			oci[i] = null;
		}

		//  L[Cxgݒ
		gk = new GameKeyAdapter();
		this.addKeyListener(gk);

		//  }EXCxgݒ
		gm = new GameMouseAdapter();
		this.addMouseListener(gm);
		this.addMouseMotionListener(gm);
	}




	//  JavaScript p\bh  

	/**
	 * ItXN[ Graphics 擾
	 * @return		ItXN[  Graphics
	 */
	public Graphics2D getOffscreenGraphics() {
		return(offscreen_g);
	}


	/**
	 * ImageObserver 擾 
	 * @return				ImageObserver
	 */ 
	public ImageObserver getImageObserver() {
		return((ImageObserver)this);
	}


	/**
	 * ItXN[̉摜 JavaApplet ɕ\
	 */
	public void printOffscreen() {


		repaint();
		return;
	}


	/**
	 * Image ^̉摜擾 
	 * @param filename		t@Cl[
	 * @return				摜
	 */ 
	public BufferedImage newImageOnLoad(String filename) {
		BufferedImage n_img = null;


		//  摜ǂݍ
		try {
			n_img = ImageIO.read(new URL(getCodeBase(),filename));
		} 	catch (Exception e) {
			e.printStackTrace();
			return(null);
		}

		//  ǂݍނ܂ő҂
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(n_img,0);
		try {
			mt.waitForID(0);
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		return(n_img);
	}

	
	//  ItXN[̐Fݒ肷
	public boolean setOffscreenColor(String st1,String st2,String st3,String st4) {
		int r = 0,g = 0,b = 0,a = 0;


		try {
			r = Integer.parseInt(st1);
			g = Integer.parseInt(st2);
			b = Integer.parseInt(st3);
			a = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			r = -9999;
		}

		if(r == -9999) return(false);
		if(r < 0) r = 0;
		if(r > 255) r = 255;
		if(g < 0) g = 0;
		if(g > 255) g = 255;
		if(b < 0) b = 0;
		if(b > 255) b = 255;
		if(a < 0) a = 0;
		if(a > 255) a = 255;

		//  ItXN[̐Fݒ肷
		offscreen_g.setColor(new Color(r,g,b,a));

		return(true);
	}
	

	//  tHg̃TCYݒ肷
	public boolean setFontSize(String st1) {
		int size = 16;


		try {
			size = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			size = -1;
		}

		if(size <= 0) return(false);

		//  TCYݒ肷
		offscreen_g.setFont(new Font("Dialog",Font.PLAIN,size));

		return(true);
	}


	/** ItXN[ɁA_R̃|S`悷B
	 *  @param  st1		_P̂wW
	 *  @param  st2		_P̂xW
	 *  @param  st3		_Q̂wW
	 *  @param  st4		_Q̂xW
	 *  @param  st5		_R̂wW
	 *  @param  st6		_R̂xW
	 */
	public boolean fillPolygon(String st1,String st2,String st3,String st4,String st5,String st6) {
		int[] px = new int[3];
		int[] py = new int[3];


		try {
			px[0] = Integer.parseInt(st1);
			py[0] = Integer.parseInt(st2);
			px[1] = Integer.parseInt(st3);
			py[1] = Integer.parseInt(st4);
			px[2] = Integer.parseInt(st5);
			py[2] = Integer.parseInt(st6);
		}
		catch (NumberFormatException e) {
			px[0] = -9999;
		}
		if(px[0] == -9999) return(false);

		//  |S`悷
		offscreen_g.fillPolygon(px,py,3);

		return(true);
	}


	/** ItXN[ɁA_S̃|S`悷B
	 *  @param  st1		_P̂wW
	 *  @param  st2		_P̂xW
	 *  @param  st3		_Q̂wW
	 *  @param  st4		_Q̂xW
	 *  @param  st5		_R̂wW
	 *  @param  st6		_R̂xW
	 *  @param  st7		_ŜwW
	 *  @param  st8		_ŜxW
	 */
	public boolean fillPolygon(String st1,String st2,String st3,String st4,String st5,String st6,String st7,String st8) {
		int[] px = new int[4];
		int[] py = new int[4];


		try {
			px[0] = Integer.parseInt(st1);
			py[0] = Integer.parseInt(st2);
			px[1] = Integer.parseInt(st3);
			py[1] = Integer.parseInt(st4);
			px[2] = Integer.parseInt(st5);
			py[2] = Integer.parseInt(st6);
			px[3] = Integer.parseInt(st7);
			py[3] = Integer.parseInt(st8);
		}
		catch (NumberFormatException e) {
			px[0] = -9999;
		}

		if(px[0] == -9999) return(false);

		//  |S`悷
		offscreen_g.fillPolygon(px,py,4);

		return(true);
	}


	/** ItXN[ɁA摜]ĕ`悷B
	 *  @param	h_img	Image IuWFNg
	 *  @param  st1		wW
	 *  @param  st2		xW
	 *  @param  st3		px (0 - 360)
	 */
	public boolean drawImageRotate(Image h_img,String st1,String st2,String st3) {
		int x = 0,y = 0,kakudo = 0,nx,ny;
		Graphics2D offscreen_g2;


		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			kakudo = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			x = -9999;
		}
		if(x == -9999) return(false);

		//  Graphics2D ^쐬
		offscreen_g2 = (Graphics2D)(offscreen_img.getGraphics());

		//  ]̒SW
		nx = x+(int)(h_img.getWidth(this)/2);
		ny = y+(int)(h_img.getHeight(this)/2);

		//  ]ݒ肷
		offscreen_g2.rotate((float)(kakudo)*3.14f/180f,nx,ny);

		//  `悷
		offscreen_g2.drawImage(h_img,x,y,this);

		return(true);
	}


	/** ItXN[ɁA摜gkĕ`悷B
	 *  @param	h_img	Image IuWFNg
	 *  @param  st1		wW
	 *  @param  st2		xW
	 *  @param  st3		wg嗦
	 *  @param  st4		xg嗦
	 */
	public boolean drawImageScale(Image h_img,String st1,String st2,String st3,String st4) {
		int x = 0,y = 0,zoom_x = 100,zoom_y = 100;
		Graphics2D offscreen_g2;


		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			zoom_x = Integer.parseInt(st3);
			zoom_y = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			x = -9999;
		}
		if(x == -9999) return(false);

		//  Graphics2D ^쐬
		offscreen_g2 = (Graphics2D)(offscreen_img.getGraphics());

		//  gkݒ肷
		offscreen_g2.translate(x,y);
       	offscreen_g2.scale((float)(zoom_x)/100f,(float)(zoom_y)/100f);

		//  `悷
		offscreen_g2.drawImage(h_img,0,0,this);

		return(true);
	}


	/**
	 * L[̏Ԃ擾 
	 * @return				tO
	 */ 
	public int isPressUpKey() {
		if(gk.up_f == true) return(1);
		return(0);
	}
	public int isPressDownKey() {
		if(gk.down_f == true) return(1);
		return(0);
	}
	public int isPressLeftKey() {
		if(gk.left_f == true) return(1);
		return(0);
	}
	public int isPressRightKey() {
		if(gk.right_f == true) return(1);
		return(0);
	}
	public int isPressSpaceKey() {
		if(gk.space_f == true) return(1);
		return(0);
	}
	public int isPressZKey() {
		if(gk.z_f == true) return(1);
		return(0);
	}
	public int isPressXKey() {
		if(gk.x_f == true) return(1);
		return(0);
	}


	/**
	 * L[R[h擾 
	 * @return				tO
	 */ 
	public int getKeyCode() {
		return((int)(gk.key_code));
	}


	/**
	 * L[R[hZbg 
	 * @return				tO
	 */ 
	public boolean resetKeyCode() {


		gk.key_code = 0;
		return(true);
	}


	/**
	 * }EXNbNXW擾 
	 * @return				tO
	 */ 
	public int getMouseClickedX() {
		return(gm.clicked_x);
	}


	/**
	 * }EXNbNYW擾 
	 * @return				tO
	 */ 
	public int getMouseClickedY() {
		return(gm.clicked_y);
	}


	/**
	 * }EX̃{^̏Ԃ擾 
	 * @return				tO
	 */ 
	public int isPressMouseButton() {
		if(gm.button_f == true) return(1);
		return(0);
	}
	

	/**
	 * }EXJ[\XW擾 
	 * @return				tO
	 */ 
	public int getMouseX() {
		if(gm.enter_f == true) return(gm.move_x);
		return(-1);
	}


	/**
	 * }EXJ[\XW擾 
	 * @return				tO
	 */ 
	public int getMouseY() {
		if(gm.enter_f == true) return(gm.move_y);
		return(-1);
	}


	/**
	 * IWi`bv摜쐬 
	 * @param				t@Cl[
	 * @param				`bvP̕
	 * @param				`bvP̍
	 * @param				`bvɕԐ
	 * @param				`bvcɕԐ
	 * @return				ChipImage  ID
	 */ 
	public int newChipImage(String filename,String st1,String st2,String st3,String st4) {
		BufferedImage img1;
		int cw = -1;
		int ch = 0;
		int xc = 0;
		int yc = 0;
		int id = 0;
		int i;


		try {
			cw = Integer.parseInt(st1);
			ch = Integer.parseInt(st2);
			xc = Integer.parseInt(st3);
			yc = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			cw = -1;
		}

		if(cw < 0) return(-1);


		//  gp̃IWi`bv摜T
		for(i = 0;i <= 255;i++){
			if(oci[i] == null) {
				break;
			}
		}
		if(i > 255) return(-1);
		id = i;

		//  摜ǂݍ
		img1 = this.newImageOnLoad(filename);
		if(img1 == null) {
			//  G[
			return(-1);
		}

		//  `bv摜쐬
		oci[id] = new ChipImage(cw,ch,xc,yc,img1);

		//  ChipImage  ID Ԃ
		return(id);
	}


	/**
	 * IWi`bv̐]摜쐬 
	 * @param				ID
	 */ 
	public boolean makeReverseChipImage(String st1) {
		int id = 0;


		try {
			id = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			id = -1;
		}

		if(id < 0) return(false);

		return(oci[id].makeReverseChipImage());
	}


	/**
	 * IWi`bv摜擾  ID w肠
	 * @param			ID
	 * @param			`bvR[h
	 * @return			`bv摜
	 */ 
	//  IWi`bv摜擾
	public BufferedImage getChipImage(String st1,String st2) {
		int id = 0,c = -1;


		try {
			id = Integer.parseInt(st1);
			c = Integer.parseInt(st2);
		}
		catch (NumberFormatException e) {
			id = -1;
		}

		if(id < 0) return(null);

		return(oci[id].getChipImage(c));
	}


	/**
	 * IWi`bv摜擾  ]񂠂
	 * @param 			ID
	 * @param			`bvR[h
	 * @param 			]
	 *							0  ]Ȃ
	 *							1  ]
	 *							2  ]
	 *							3  ]
	 * @return			`bv摜
	 */ 
	public BufferedImage getChipImage(String st1,String st2,String st3) {
		int id = 0,c = -1,r = 0;


		try {
			id = Integer.parseInt(st1);
			c = Integer.parseInt(st2);
			r = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			id = -1;
		}

		if(id < 0) return(null);
		if(c < 0) return(null);
		if(r < 0  ||  r > 3) r = 0;

		return(oci[id].getChipImage(c,r));
	}


	/**
	 * IWi`bv摜j
	 * @param 			ID
	 * @return			`bv摜
	 */ 
	public boolean disposeChipImage(String st1) {
		int id = 0;


		try {
			id = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			id = -1;
		}

		if(id < 0) return(false);

		oci[id] = null;

		return(true);
	}
}
